// GosCommand.cpp : implementation file
//

#include "stdafx.h"
#include "GosCommand.h"
#include "Gos.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGosCommand

void CGosCommand::gosConnect(int port)
{
	BOOL bValue = TRUE;
	SetSockOpt(TCP_NODELAY, (void*)&bValue, sizeof(BOOL));
	m_nPort = port;
	Connect(_T("localhost"), port);
}

void CGosCommand::gosClose()
{
	Close();
}

CGosCommand::CGosCommand()
{
	m_hWnd = NULL;
}

CGosCommand::CGosCommand(HWND hWnd)
{
	m_hWnd = hWnd;
}

CGosCommand::~CGosCommand()
{
}


// Do not edit the following lines, which are needed by ClassWizard.
#if 0
BEGIN_MESSAGE_MAP(CGosCommand, CAsyncSocket)
	//{{AFX_MSG_MAP(CGosCommand)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
#endif	// 0

/////////////////////////////////////////////////////////////////////////////
// CGosCommand member functions

void CGosCommand::OnReceive(int nErrorCode) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	const int iBuffLen = 4096;
	TCHAR tBuff[iBuffLen];
	int iLen;

	iLen = Receive(tBuff, iBuffLen);
	tBuff[iLen] = 0;
	
	if (!tBuff[0] == (char)PIMD) return;

	CString sData = tBuff;
	sData = sData.Mid(1); //cut off the first message-delimiter char
	int iniPos = 0, finPos;
	finPos = sData.Find(PIMD);
	while (!(finPos == -1))
	{
		CString sLine;
		sLine = sData.Mid(iniPos, (finPos - iniPos));
		//AfxMessageBox(sLine, 0, 0);
		Dispatch(sLine);
		finPos++;
		iniPos = finPos;
		finPos = sData.Find(PIMD, iniPos);
	}
	CString sLine = sData.Mid(iniPos); 
	Dispatch(sLine);

	CAsyncSocket::OnReceive(nErrorCode);
}

void CGosCommand::OnClose(int nErrorCode) 
{
	// TODO: Add your specialized code here and/or call the base class
	SendClose();
	CAsyncSocket::OnClose(nErrorCode);
}

void CGosCommand::OnConnect(int nErrorCode) 
{
	// TODO: Add your specialized code here and/or call the base class

	CAsyncSocket::OnConnect(nErrorCode);
}

void CGosCommand::SendOutput(CString sData, int nType)
{
	if (!m_hWnd == NULL)
	{
		gosOutputStruct gos; 
		gos.lpOut = (LPCTSTR)sData;
		gos.nType = nType;
		SendMessage(m_hWnd, GS_OUTPUT, 0, (LPARAM)&gos);
	}
}

void CGosCommand::SendInput(CString sData, int nType)
{
	if (!m_hWnd == NULL)
	{
		gosInputStruct gis; 
		gis.lpIn = (LPCTSTR)sData;
		gis.nType = nType;
		BOOL rtn = SendMessage(m_hWnd, GS_INPUT, 0, (LPARAM)&gis);
	}
}

void CGosCommand::SendNotify(int nCode)
{
	if (!m_hWnd == NULL)
	{
		PostMessage(m_hWnd, GS_NOTIFY, (WPARAM)nCode, 0);
	}
}

void CGosCommand::SendGo()
{
	if (!m_hWnd == NULL)
	{
		PostMessage(m_hWnd, GS_GO, 0, 0);
	}
}

void CGosCommand::SendClose()
{
	if (!m_hWnd == NULL)
	{
		PostMessage(m_hWnd, GS_CLOSE, 0, 0);
	}
}

void CGosCommand::gosSendOutput(CString sData, int nType)
{
	CString sSend = PIMD;
	switch (nType)
	{
		case TOUT_STATUS:
			//sData.Format(_T("008 %s"), sData);
			sSend += "008 ";
			break;
		case TOUT_ERROR:
			//sData.Format(_T("007 %s"), sData);
			sSend += "007 ";
			break;
		default:
			return;
	}
	sSend += sData;
	Send(sSend, sSend.GetLength());
}

void CGosCommand::gosSendInput(CString sData, int nType)
{
	CString sSend = PIMD;
	switch (nType)
	{
		case TIN_NORMAL:
			//sData.Format(_T("005 %s"), sData);
			sSend += "005 ";
			break;
		case TIN_TOQUEUE:
			//sData.Format(_T("006 %s"), sData);
			sSend += "006 ";
			break;
		default:
			return;
	}
	
	sSend += sData;
	Send(sSend, sSend.GetLength());
}


void CGosCommand::Dispatch(CString sData)
{
	int nMsgType = _ttoi(sData.Left(3));
	sData = sData.Right(sData.GetLength() - 4);
	switch (nMsgType)
	{
		//codici che riprendono le comunicazioni della cEnviron
		case 1: //inizializzazione completata
			SendGo();
			break;
		case 2: //primo invio di output per bloccarlo
			SendOutput(sData, TOUT_FIRST);
			break;
		case 3: //output normale
			SendOutput(sData, TOUT_NORMAL);
			break;
		case 4: //output "clean", ripulito dei codici ansi
			SendOutput(sData, TOUT_CLEAN);
			break;
		case 5: //input gia' inviato
			SendInput(sData, TIN_NORMAL);
			break;
		case 10: //notify
			SendNotify(_ttoi(sData));
			break;
		
		//codici per le cartelle e le info sul client
		case 50: //nome del mud selezionato
			m_gi.sMudName = sData;
			break;
		case 51: //nome del profilo selezionato
			m_gi.sProfName = sData;
			break;
		case 52: //cartella del client
			m_gi.sClientPath = sData;
			break;
		case 53: //cartella del mud
			m_gi.sMudPath = sData;
			break;
		case 54: //cartella del profilo
			m_gi.sProfPath = sData;
			break;
	}
}

CString CGosCommand::gosMudName()
{
	return m_gi.sMudName;
}

CString CGosCommand::gosProfName()
{
	return m_gi.sProfName;
}

CString CGosCommand::gosClientPath()
{
	return m_gi.sClientPath;
}

CString CGosCommand::gosMudPath()
{
	return m_gi.sMudPath;
}

CString CGosCommand::gosProfPath()
{
	return m_gi.sProfPath;
}

void CGosCommand::gosLeaveOutput()
{
	CString sSend = PIMD;
	sSend += "011";
	Send(sSend, sSend.GetLength());
}

void CGosCommand::gosStopOutput(CString sNewData)
{
	CString sSend = PIMD;
	sSend += "012 ";
	sSend += sNewData;
	Send(sSend, sSend.GetLength());
}